org.apache.commons.math3.linear

## Class BlockRealMatrix

- java.lang.Object
- - org.apache.commons.math3.linear.RealLinearOperator
  - - org.apache.commons.math3.linear.AbstractRealMatrix
    - - org.apache.commons.math3.linear.BlockRealMatrix

All Implemented Interfaces:
  java.io.Serializable, AnyMatrix, RealMatrix

    public class BlockRealMatrix
    extends AbstractRealMatrix
    implements java.io.Serializable

Cache-friendly implementation of RealMatrix using a flat arrays to store square blocks of the matrix.

This implementation is specially designed to be cache-friendly. Square blocks are stored as small arrays and allow efficient traversal of data both in row major direction and columns major direction, one block at a time. This greatly increases performances for algorithms that use crossed directions loops like multiplication or transposition.

The size of square blocks is a static parameter. It may be tuned according to the cache size of the target computer processor. As a rule of thumbs, it should be the largest value that allows three blocks to be simultaneously cached (this is necessary for example for matrix multiplication). The default value is to use 52x52 blocks which is well suited for processors with 64k L1 cache (one block holds 2704 values or 21632 bytes). This value could be lowered to 36x36 for processors with 32k L1 cache.

The regular blocks represent `BLOCK_SIZE` x `BLOCK_SIZE` squares. Blocks at right hand side and bottom side which may be smaller to fit matrix dimensions. The square blocks are flattened in row major order in single dimension arrays which are therefore `BLOCK_SIZE`2 elements long for regular blocks. The blocks are themselves organized in row major order.

As an example, for a block size of 52x52, a 100x60 matrix would be stored in 4 blocks. Block 0 would be a double[2704] array holding the upper left 52x52 square, block 1 would be a double[416] array holding the upper right 52x8 rectangle, block 2 would be a double[2496] array holding the lower left 48x52 rectangle and block 3 would be a double[384] array holding the lower right 48x8 rectangle.

The layout complexity overhead versus simple mapping of matrices to java arrays is negligible for small matrices (about 1%). The gain from cache efficiency leads to up to 3-fold improvements for matrices of moderate to large size.

Since:
  2.0
Version:
  $Id: BlockRealMatrix.java 1416643 2012-12-03 19:37:14Z tn $
See Also:
  Serialized Form

### Field Summary

Fields
`static int` `BLOCK_SIZE` Block size.
`private int` `blockColumns` Number of block columns of the matrix.
`private int` `blockRows` Number of block rows of the matrix.
`private double[][]` `blocks` Blocks of matrix entries.
`private int` `columns` Number of columns of the matrix.
`private int` `rows` Number of rows of the matrix.
`private static long` `serialVersionUID` Serializable version identifier

### Constructor Summary

Constructors
Constructor and Description
`BlockRealMatrix(double[][] rawData)` Create a new dense matrix copying entries from raw layout data.
`BlockRealMatrix(int rows, int columns)` Create a new matrix with the supplied row and column dimensions.
`BlockRealMatrix(int rows, int columns, double[][] blockData, boolean copyArray)` Create a new dense matrix copying entries from block layout data.

### Method Summary

Methods
`BlockRealMatrix` `add(BlockRealMatrix m)` Compute the sum of this matrix and `m`.
`BlockRealMatrix` `add(RealMatrix m)` Returns the sum of `this` and `m`.
`void` `addToEntry(int row, int column, double increment)` Adds (in place) the specified value to the specified entry of `this` matrix.
`private int` `blockHeight(int blockRow)` Get the height of a block.
`private int` `blockWidth(int blockColumn)` Get the width of a block.
`BlockRealMatrix` `copy()` Returns a (deep) copy of this.
`private void` `copyBlockPart(double[] srcBlock, int srcWidth, int srcStartRow, int srcEndRow, int srcStartColumn, int srcEndColumn, double[] dstBlock, int dstWidth, int dstStartRow, int dstStartColumn)` Copy a part of a block into another one
`static double[][]` `createBlocksLayout(int rows, int columns)` Create a data array in blocks layout.
`BlockRealMatrix` `createMatrix(int rowDimension, int columnDimension)` Create a new RealMatrix of the same type as the instance with the supplied row and column dimensions.
`double[]` `getColumn(int column)` Get the entries at the given column index as an array.
`int` `getColumnDimension()` Returns the number of columns of this matrix.
`BlockRealMatrix` `getColumnMatrix(int column)` Get the entries at the given column index as a column matrix.
`RealVector` `getColumnVector(int column)` Get the entries at the given column index as a vector.
`double[][]` `getData()` Returns matrix entries as a two-dimensional array.
`double` `getEntry(int row, int column)` Get the entry in the specified row and column.
`double` `getFrobeniusNorm()` Returns the Frobenius norm of the matrix.
`double` `getNorm()` Returns the maximum absolute row sum norm of the matrix.
`double[]` `getRow(int row)` Get the entries at the given row index.
`int` `getRowDimension()` Returns the number of rows of this matrix.
`BlockRealMatrix` `getRowMatrix(int row)` Get the entries at the given row index as a row matrix.
`RealVector` `getRowVector(int row)` Returns the entries in row number `row` as a vector.
`BlockRealMatrix` `getSubMatrix(int startRow, int endRow, int startColumn, int endColumn)` Gets a submatrix.
`BlockRealMatrix` `multiply(BlockRealMatrix m)` Returns the result of postmultiplying this by `m`.
`BlockRealMatrix` `multiply(RealMatrix m)` Returns the result of postmultiplying `this` by `m`.
`void` `multiplyEntry(int row, int column, double factor)` Multiplies (in place) the specified entry of `this` matrix by the specified value.
`double[]` `operate(double[] v)` Returns the result of multiplying this by the vector `v`.
`double[]` `preMultiply(double[] v)` Returns the (row) vector result of premultiplying this by the vector `v`.
`BlockRealMatrix` `scalarAdd(double d)` Returns the result of adding `d` to each entry of `this`.
`RealMatrix` `scalarMultiply(double d)` Returns the result of multiplying each entry of `this` by `d`.
`void` `setColumn(int column, double[] array)` Sets the specified `column` of `this` matrix to the entries of the specified `array`.
`(package private) void` `setColumnMatrix(int column, BlockRealMatrix matrix)` Sets the entries in column number `column` as a column matrix.
`void` `setColumnMatrix(int column, RealMatrix matrix)` Sets the specified `column` of `this` matrix to the entries of the specified column `matrix`.
`void` `setColumnVector(int column, RealVector vector)` Sets the specified `column` of `this` matrix to the entries of the specified `vector`.
`void` `setEntry(int row, int column, double value)` Set the entry in the specified row and column.
`void` `setRow(int row, double[] array)` Sets the specified `row` of `this` matrix to the entries of the specified `array`.
`void` `setRowMatrix(int row, BlockRealMatrix matrix)` Sets the entries in row number `row` as a row matrix.
`void` `setRowMatrix(int row, RealMatrix matrix)` Sets the specified `row` of `this` matrix to the entries of the specified row `matrix`.
`void` `setRowVector(int row, RealVector vector)` Sets the specified `row` of `this` matrix to the entries of the specified `vector`.
`void` `setSubMatrix(double[][] subMatrix, int row, int column)` Replace the submatrix starting at `row, column` using data in the input `subMatrix` array.
`BlockRealMatrix` `subtract(BlockRealMatrix m)` Subtract `m` from this matrix.
`BlockRealMatrix` `subtract(RealMatrix m)` Returns `this` minus `m`.
`static double[][]` `toBlocksLayout(double[][] rawData)` Convert a data array from raw layout to blocks layout.
`BlockRealMatrix` `transpose()` Returns the transpose of this matrix.
`double` `walkInOptimizedOrder(RealMatrixChangingVisitor visitor)` Visit (and possibly change) all matrix entries using the fastest possible order.
`double` `walkInOptimizedOrder(RealMatrixChangingVisitor visitor, int startRow, int endRow, int startColumn, int endColumn)` Visit (and possibly change) some matrix entries using the fastest possible order.
`double` `walkInOptimizedOrder(RealMatrixPreservingVisitor visitor)` Visit (but don't change) all matrix entries using the fastest possible order.
`double` `walkInOptimizedOrder(RealMatrixPreservingVisitor visitor, int startRow, int endRow, int startColumn, int endColumn)` Visit (but don't change) some matrix entries using the fastest possible order.
`double` `walkInRowOrder(RealMatrixChangingVisitor visitor)` Visit (and possibly change) all matrix entries in row order.
`double` `walkInRowOrder(RealMatrixChangingVisitor visitor, int startRow, int endRow, int startColumn, int endColumn)` Visit (and possibly change) some matrix entries in row order.
`double` `walkInRowOrder(RealMatrixPreservingVisitor visitor)` Visit (but don't change) all matrix entries in row order.
`double` `walkInRowOrder(RealMatrixPreservingVisitor visitor, int startRow, int endRow, int startColumn, int endColumn)` Visit (but don't change) some matrix entries in row order.

### Methods inherited from class org.apache.commons.math3.linear.AbstractRealMatrix

`copySubMatrix, copySubMatrix, equals, getSubMatrix, getTrace, hashCode, isSquare, operate, power, preMultiply, preMultiply, toString, walkInColumnOrder, walkInColumnOrder, walkInColumnOrder, walkInColumnOrder`

### Methods inherited from class org.apache.commons.math3.linear.RealLinearOperator

`isTransposable, operateTranspose`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Field Detail

#### BLOCK_SIZE

    public static final int BLOCK_SIZE

Block size.

See Also:
  Constant Field Values

#### serialVersionUID

    private static final long serialVersionUID

Serializable version identifier

See Also:
  Constant Field Values

#### blocks

    private final double[][] blocks

Blocks of matrix entries.

#### rows

    private final int rows

Number of rows of the matrix.

#### columns

    private final int columns

Number of columns of the matrix.

#### blockRows

    private final int blockRows

Number of block rows of the matrix.

#### blockColumns

    private final int blockColumns

Number of block columns of the matrix.

### Constructor Detail

#### BlockRealMatrix

    public BlockRealMatrix(int rows,
                   int columns)
                    throws NotStrictlyPositiveException

Create a new matrix with the supplied row and column dimensions.

Parameters:
  `rows` - the number of rows in the new matrix
  `columns` - the number of columns in the new matrix
Throws:
  `NotStrictlyPositiveException` - if row or column dimension is not positive.

#### BlockRealMatrix

    public BlockRealMatrix(double[][] rawData)
                    throws DimensionMismatchException,
                           NotStrictlyPositiveException

Create a new dense matrix copying entries from raw layout data.

The input array must already be in raw layout.

Calling this constructor is equivalent to call:

    matrix = new BlockRealMatrix(rawData.length, rawData[0].length,
                                       toBlocksLayout(rawData), false);

Parameters:
  `rawData` - data for new matrix, in raw layout
Throws:
  `DimensionMismatchException` - if the shape of `blockData` is inconsistent with block layout.
  `NotStrictlyPositiveException` - if row or column dimension is not positive.
See Also:
  `BlockRealMatrix(int, int, double[][], boolean)`

#### BlockRealMatrix

    public BlockRealMatrix(int rows,
                   int columns,
                   double[][] blockData,
                   boolean copyArray)
                    throws DimensionMismatchException,
                           NotStrictlyPositiveException

Create a new dense matrix copying entries from block layout data.

The input array must already be in blocks layout.

Parameters:
  `rows` - Number of rows in the new matrix.
  `columns` - Number of columns in the new matrix.
  `blockData` - data for new matrix
  `copyArray` - Whether the input array will be copied or referenced.
Throws:
  `DimensionMismatchException` - if the shape of `blockData` is inconsistent with block layout.
  `NotStrictlyPositiveException` - if row or column dimension is not positive.
See Also:
  `createBlocksLayout(int, int)`, `toBlocksLayout(double[][])`, `BlockRealMatrix(double[][])`

### Method Detail

#### toBlocksLayout

    public static double[][] toBlocksLayout(double[][] rawData)
                                     throws DimensionMismatchException

Convert a data array from raw layout to blocks layout.

Raw layout is the straightforward layout where element at row i and column j is in array element `rawData[i][j]`. Blocks layout is the layout used in `BlockRealMatrix` instances, where the matrix is split in square blocks (except at right and bottom side where blocks may be rectangular to fit matrix size) and each block is stored in a flattened one-dimensional array.

This method creates an array in blocks layout from an input array in raw layout. It can be used to provide the array argument of the `BlockRealMatrix(int, int, double[][], boolean)` constructor.

Parameters:
  `rawData` - Data array in raw layout.
Returns:
  a new data array containing the same entries but in blocks layout.
Throws:
  `DimensionMismatchException` - if `rawData` is not rectangular.
See Also:
  `createBlocksLayout(int, int)`, `BlockRealMatrix(int, int, double[][], boolean)`

#### createBlocksLayout

    public static double[][] createBlocksLayout(int rows,
                                int columns)

Create a data array in blocks layout.

This method can be used to create the array argument of the `BlockRealMatrix(int, int, double[][], boolean)` constructor.

Parameters:
  `rows` - Number of rows in the new matrix.
  `columns` - Number of columns in the new matrix.
Returns:
  a new data array in blocks layout.
See Also:
  `toBlocksLayout(double[][])`, `BlockRealMatrix(int, int, double[][], boolean)`

#### createMatrix

    public BlockRealMatrix createMatrix(int rowDimension,
                               int columnDimension)
                                 throws NotStrictlyPositiveException

Create a new RealMatrix of the same type as the instance with the supplied row and column dimensions.

Specified by:
  `createMatrix` in interface `RealMatrix`
Specified by:
  `createMatrix` in class `AbstractRealMatrix`
Parameters:
  `rowDimension` - the number of rows in the new matrix
  `columnDimension` - the number of columns in the new matrix
Returns:
  a new matrix of the same type as the instance
Throws:
  `NotStrictlyPositiveException` - if row or column dimension is not positive.

#### copy

    public BlockRealMatrix copy()

Returns a (deep) copy of this.

Specified by:
  `copy` in interface `RealMatrix`
Specified by:
  `copy` in class `AbstractRealMatrix`
Returns:
  matrix copy

#### add

    public BlockRealMatrix add(RealMatrix m)
                        throws MatrixDimensionMismatchException

Returns the sum of `this` and `m`.

Specified by:
  `add` in interface `RealMatrix`
Overrides:
  `add` in class `AbstractRealMatrix`
Parameters:
  `m` - matrix to be added
Returns:
  `this + m`
Throws:
  `MatrixDimensionMismatchException` - if `m` is not the same size as `this`.

#### add

    public BlockRealMatrix add(BlockRealMatrix m)
                        throws MatrixDimensionMismatchException

Compute the sum of this matrix and `m`.

Parameters:
  `m` - Matrix to be added.
Returns:
  `this` + m.
Throws:
  `MatrixDimensionMismatchException` - if `m` is not the same size as this matrix.

#### subtract

    public BlockRealMatrix subtract(RealMatrix m)
                             throws MatrixDimensionMismatchException

Returns `this` minus `m`.

Specified by:
  `subtract` in interface `RealMatrix`
Overrides:
  `subtract` in class `AbstractRealMatrix`
Parameters:
  `m` - matrix to be subtracted
Returns:
  `this - m`
Throws:
  `MatrixDimensionMismatchException` - if `m` is not the same size as `this`.

#### subtract

    public BlockRealMatrix subtract(BlockRealMatrix m)
                             throws MatrixDimensionMismatchException

Subtract `m` from this matrix.

Parameters:
  `m` - Matrix to be subtracted.
Returns:
  `this` - m.
Throws:
  `MatrixDimensionMismatchException` - if `m` is not the same size as this matrix.

#### scalarAdd

    public BlockRealMatrix scalarAdd(double d)

Returns the result of adding `d` to each entry of `this`.

Specified by:
  `scalarAdd` in interface `RealMatrix`
Overrides:
  `scalarAdd` in class `AbstractRealMatrix`
Parameters:
  `d` - value to be added to each entry
Returns:
  `d + this`

#### scalarMultiply

    public RealMatrix scalarMultiply(double d)

Returns the result of multiplying each entry of `this` by `d`.

Specified by:
  `scalarMultiply` in interface `RealMatrix`
Overrides:
  `scalarMultiply` in class `AbstractRealMatrix`
Parameters:
  `d` - value to multiply all entries by
Returns:
  `d * this`

#### multiply

    public BlockRealMatrix multiply(RealMatrix m)
                             throws DimensionMismatchException

Returns the result of postmultiplying `this` by `m`.

Specified by:
  `multiply` in interface `RealMatrix`
Overrides:
  `multiply` in class `AbstractRealMatrix`
Parameters:
  `m` - matrix to postmultiply by
Returns:
  `this * m`
Throws:
  `DimensionMismatchException` - if `columnDimension(this) != rowDimension(m)`

#### multiply

    public BlockRealMatrix multiply(BlockRealMatrix m)
                             throws DimensionMismatchException

Returns the result of postmultiplying this by `m`.

Parameters:
  `m` - Matrix to postmultiply by.
Returns:
  `this` * m.
Throws:
  `DimensionMismatchException` - if the matrices are not compatible.

#### getData

    public double[][] getData()

Returns matrix entries as a two-dimensional array.

Specified by:
  `getData` in interface `RealMatrix`
Overrides:
  `getData` in class `AbstractRealMatrix`
Returns:
  2-dimensional array of entries

#### getNorm

    public double getNorm()

Returns the maximum absolute row sum norm of the matrix.

Specified by:
  `getNorm` in interface `RealMatrix`
Overrides:
  `getNorm` in class `AbstractRealMatrix`
Returns:
  norm

#### getFrobeniusNorm

    public double getFrobeniusNorm()

Returns the Frobenius norm of the matrix.

Specified by:
  `getFrobeniusNorm` in interface `RealMatrix`
Overrides:
  `getFrobeniusNorm` in class `AbstractRealMatrix`
Returns:
  norm

#### getSubMatrix

    public BlockRealMatrix getSubMatrix(int startRow,
                               int endRow,
                               int startColumn,
                               int endColumn)
                                 throws OutOfRangeException,
                                        NumberIsTooSmallException

Gets a submatrix. Rows and columns are indicated counting from 0 to n-1.

Specified by:
  `getSubMatrix` in interface `RealMatrix`
Overrides:
  `getSubMatrix` in class `AbstractRealMatrix`
Parameters:
  `startRow` - Initial row index
  `endRow` - Final row index (inclusive)
  `startColumn` - Initial column index
  `endColumn` - Final column index (inclusive)
Returns:
  The subMatrix containing the data of the specified rows and columns.
Throws:
  `OutOfRangeException` - if the indices are not valid.
  `NumberIsTooSmallException` - if `endRow < startRow` or `endColumn < startColumn`.

#### copyBlockPart

    private void copyBlockPart(double[] srcBlock,
                     int srcWidth,
                     int srcStartRow,
                     int srcEndRow,
                     int srcStartColumn,
                     int srcEndColumn,
                     double[] dstBlock,
                     int dstWidth,
                     int dstStartRow,
                     int dstStartColumn)

Copy a part of a block into another one

This method can be called only when the specified part fits in both blocks, no verification is done here.

Parameters:
  `srcBlock` - source block
  `srcWidth` - source block width (`BLOCK_SIZE` or smaller)
  `srcStartRow` - start row in the source block
  `srcEndRow` - end row (exclusive) in the source block
  `srcStartColumn` - start column in the source block
  `srcEndColumn` - end column (exclusive) in the source block
  `dstBlock` - destination block
  `dstWidth` - destination block width (`BLOCK_SIZE` or smaller)
  `dstStartRow` - start row in the destination block
  `dstStartColumn` - start column in the destination block

#### setSubMatrix

    public void setSubMatrix(double[][] subMatrix,
                    int row,
                    int column)
                      throws OutOfRangeException,
                             NoDataException,
                             NullArgumentException,
                             DimensionMismatchException

Replace the submatrix starting at `row, column` using data in the input `subMatrix` array. Indexes are 0-based.

Example:
Starting with

     1  2  3  4
     5  6  7  8
     9  0  1  2

and `subMatrix = {{3, 4} {5,6}}`, invoking `setSubMatrix(subMatrix,1,1))` will result in

     1  2  3  4
     5  3  4  8
     9  5  6  2

Specified by:
  `setSubMatrix` in interface `RealMatrix`
Overrides:
  `setSubMatrix` in class `AbstractRealMatrix`
Parameters:
  `subMatrix` - array containing the submatrix replacement data
  `row` - row coordinate of the top, left element to be replaced
  `column` - column coordinate of the top, left element to be replaced
Throws:
  `OutOfRangeException` - if `subMatrix` does not fit into this matrix from element in `(row, column)`.
  `NoDataException` - if `subMatrix` is empty.
  `NullArgumentException` - if `subMatrix` is `null`.
  `DimensionMismatchException` - if `subMatrix` is not rectangular (not all rows have the same length) or empty.

#### getRowMatrix

    public BlockRealMatrix getRowMatrix(int row)
                                 throws OutOfRangeException

Get the entries at the given row index as a row matrix. Row indices start at 0.

Specified by:
  `getRowMatrix` in interface `RealMatrix`
Overrides:
  `getRowMatrix` in class `AbstractRealMatrix`
Parameters:
  `row` - Row to be fetched.
Returns:
  row Matrix.
Throws:
  `OutOfRangeException` - if the specified row index is invalid.

#### setRowMatrix

    public void setRowMatrix(int row,
                    RealMatrix matrix)
                      throws OutOfRangeException,
                             MatrixDimensionMismatchException

Sets the specified `row` of `this` matrix to the entries of the specified row `matrix`. Row indices start at 0.

Specified by:
  `setRowMatrix` in interface `RealMatrix`
Overrides:
  `setRowMatrix` in class `AbstractRealMatrix`
Parameters:
  `row` - Row to be set.
  `matrix` - Row matrix to be copied (must have one row and the same number of columns as the instance).
Throws:
  `OutOfRangeException` - if the specified row index is invalid.
  `MatrixDimensionMismatchException` - if the row dimension of the `matrix` is not `1`, or the column dimensions of `this` and `matrix` do not match.

#### setRowMatrix

    public void setRowMatrix(int row,
                    BlockRealMatrix matrix)
                      throws OutOfRangeException,
                             MatrixDimensionMismatchException

Sets the entries in row number `row` as a row matrix. Row indices start at 0.

Parameters:
  `row` - the row to be set
  `matrix` - row matrix (must have one row and the same number of columns as the instance)
Throws:
  `OutOfRangeException` - if the specified row index is invalid.
  `MatrixDimensionMismatchException` - if the matrix dimensions do not match one instance row.

#### getColumnMatrix

    public BlockRealMatrix getColumnMatrix(int column)
                                    throws OutOfRangeException

Get the entries at the given column index as a column matrix. Column indices start at 0.

Specified by:
  `getColumnMatrix` in interface `RealMatrix`
Overrides:
  `getColumnMatrix` in class `AbstractRealMatrix`
Parameters:
  `column` - Column to be fetched.
Returns:
  column Matrix.
Throws:
  `OutOfRangeException` - if the specified column index is invalid.

#### setColumnMatrix

    public void setColumnMatrix(int column,
                       RealMatrix matrix)
                         throws OutOfRangeException,
                                MatrixDimensionMismatchException

Sets the specified `column` of `this` matrix to the entries of the specified column `matrix`. Column indices start at 0.

Specified by:
  `setColumnMatrix` in interface `RealMatrix`
Overrides:
  `setColumnMatrix` in class `AbstractRealMatrix`
Parameters:
  `column` - Column to be set.
  `matrix` - Column matrix to be copied (must have one column and the same number of rows as the instance).
Throws:
  `OutOfRangeException` - if the specified column index is invalid.
  `MatrixDimensionMismatchException` - if the column dimension of the `matrix` is not `1`, or the row dimensions of `this` and `matrix` do not match.

#### setColumnMatrix

    void setColumnMatrix(int column,
                       BlockRealMatrix matrix)
                   throws OutOfRangeException,
                          MatrixDimensionMismatchException

Sets the entries in column number `column` as a column matrix. Column indices start at 0.

Parameters:
  `column` - the column to be set
  `matrix` - column matrix (must have one column and the same number of rows as the instance)
Throws:
  `OutOfRangeException` - if the specified column index is invalid.
  `MatrixDimensionMismatchException` - if the matrix dimensions do not match one instance column.

#### getRowVector

    public RealVector getRowVector(int row)
                            throws OutOfRangeException

Returns the entries in row number `row` as a vector. Row indices start at 0.

Specified by:
  `getRowVector` in interface `RealMatrix`
Overrides:
  `getRowVector` in class `AbstractRealMatrix`
Parameters:
  `row` - Row to be fetched.
Returns:
  a row vector.
Throws:
  `OutOfRangeException` - if the specified row index is invalid.

#### setRowVector

    public void setRowVector(int row,
                    RealVector vector)
                      throws OutOfRangeException,
                             MatrixDimensionMismatchException

Sets the specified `row` of `this` matrix to the entries of the specified `vector`. Row indices start at 0.

Specified by:
  `setRowVector` in interface `RealMatrix`
Overrides:
  `setRowVector` in class `AbstractRealMatrix`
Parameters:
  `row` - Row to be set.
  `vector` - row vector to be copied (must have the same number of column as the instance).
Throws:
  `OutOfRangeException` - if the specified row index is invalid.
  `MatrixDimensionMismatchException` - if the `vector` dimension does not match the column dimension of `this` matrix.

#### getColumnVector

    public RealVector getColumnVector(int column)
                               throws OutOfRangeException

Get the entries at the given column index as a vector. Column indices start at 0.

Specified by:
  `getColumnVector` in interface `RealMatrix`
Overrides:
  `getColumnVector` in class `AbstractRealMatrix`
Parameters:
  `column` - Column to be fetched.
Returns:
  a column vector.
Throws:
  `OutOfRangeException` - if the specified column index is invalid

#### setColumnVector

    public void setColumnVector(int column,
                       RealVector vector)
                         throws OutOfRangeException,
                                MatrixDimensionMismatchException

Sets the specified `column` of `this` matrix to the entries of the specified `vector`. Column indices start at 0.

Specified by:
  `setColumnVector` in interface `RealMatrix`
Overrides:
  `setColumnVector` in class `AbstractRealMatrix`
Parameters:
  `column` - Column to be set.
  `vector` - column vector to be copied (must have the same number of rows as the instance).
Throws:
  `OutOfRangeException` - if the specified column index is invalid.
  `MatrixDimensionMismatchException` - if the `vector` dimension does not match the row dimension of `this` matrix.

#### getRow

    public double[] getRow(int row)
                    throws OutOfRangeException

Get the entries at the given row index. Row indices start at 0.

Specified by:
  `getRow` in interface `RealMatrix`
Overrides:
  `getRow` in class `AbstractRealMatrix`
Parameters:
  `row` - Row to be fetched.
Returns:
  the array of entries in the row.
Throws:
  `OutOfRangeException` - if the specified row index is not valid.

#### setRow

    public void setRow(int row,
              double[] array)
                throws OutOfRangeException,
                       MatrixDimensionMismatchException

Sets the specified `row` of `this` matrix to the entries of the specified `array`. Row indices start at 0.

Specified by:
  `setRow` in interface `RealMatrix`
Overrides:
  `setRow` in class `AbstractRealMatrix`
Parameters:
  `row` - Row to be set.
  `array` - Row matrix to be copied (must have the same number of columns as the instance)
Throws:
  `OutOfRangeException` - if the specified row index is invalid.
  `MatrixDimensionMismatchException` - if the `array` length does not match the column dimension of `this` matrix.

#### getColumn

    public double[] getColumn(int column)
                       throws OutOfRangeException

Get the entries at the given column index as an array. Column indices start at 0.

Specified by:
  `getColumn` in interface `RealMatrix`
Overrides:
  `getColumn` in class `AbstractRealMatrix`
Parameters:
  `column` - Column to be fetched.
Returns:
  the array of entries in the column.
Throws:
  `OutOfRangeException` - if the specified column index is not valid.

#### setColumn

    public void setColumn(int column,
                 double[] array)
                   throws OutOfRangeException,
                          MatrixDimensionMismatchException

Sets the specified `column` of `this` matrix to the entries of the specified `array`. Column indices start at 0.

Specified by:
  `setColumn` in interface `RealMatrix`
Overrides:
  `setColumn` in class `AbstractRealMatrix`
Parameters:
  `column` - Column to be set.
  `array` - Column array to be copied (must have the same number of rows as the instance).
Throws:
  `OutOfRangeException` - if the specified column index is invalid.
  `MatrixDimensionMismatchException` - if the `array` length does not match the row dimension of `this` matrix.

#### getEntry

    public double getEntry(int row,
                  int column)
                    throws OutOfRangeException

Get the entry in the specified row and column. Row and column indices start at 0.

Specified by:
  `getEntry` in interface `RealMatrix`
Specified by:
  `getEntry` in class `AbstractRealMatrix`
Parameters:
  `row` - Row index of entry to be fetched.
  `column` - Column index of entry to be fetched.
Returns:
  the matrix entry at `(row, column)`.
Throws:
  `OutOfRangeException` - if the row or column index is not valid.

#### setEntry

    public void setEntry(int row,
                int column,
                double value)
                  throws OutOfRangeException

Set the entry in the specified row and column. Row and column indices start at 0.

Specified by:
  `setEntry` in interface `RealMatrix`
Specified by:
  `setEntry` in class `AbstractRealMatrix`
Parameters:
  `row` - Row index of entry to be set.
  `column` - Column index of entry to be set.
  `value` - the new value of the entry.
Throws:
  `OutOfRangeException` - if the row or column index is not valid

#### addToEntry

    public void addToEntry(int row,
                  int column,
                  double increment)
                    throws OutOfRangeException

Adds (in place) the specified value to the specified entry of `this` matrix. Row and column indices start at 0.

Specified by:
  `addToEntry` in interface `RealMatrix`
Overrides:
  `addToEntry` in class `AbstractRealMatrix`
Parameters:
  `row` - Row index of the entry to be modified.
  `column` - Column index of the entry to be modified.
  `increment` - value to add to the matrix entry.
Throws:
  `OutOfRangeException` - if the row or column index is not valid.

#### multiplyEntry

    public void multiplyEntry(int row,
                     int column,
                     double factor)
                       throws OutOfRangeException

Multiplies (in place) the specified entry of `this` matrix by the specified value. Row and column indices start at 0.

Specified by:
  `multiplyEntry` in interface `RealMatrix`
Overrides:
  `multiplyEntry` in class `AbstractRealMatrix`
Parameters:
  `row` - Row index of the entry to be modified.
  `column` - Column index of the entry to be modified.
  `factor` - Multiplication factor for the matrix entry.
Throws:
  `OutOfRangeException` - if the row or column index is not valid.

#### transpose

    public BlockRealMatrix transpose()

Returns the transpose of this matrix.

Specified by:
  `transpose` in interface `RealMatrix`
Overrides:
  `transpose` in class `AbstractRealMatrix`
Returns:
  transpose matrix

#### getRowDimension

    public int getRowDimension()

Returns the number of rows of this matrix.

Specified by:
  `getRowDimension` in interface `AnyMatrix`
Specified by:
  `getRowDimension` in class `AbstractRealMatrix`
Returns:
  the number of rows.

#### getColumnDimension

    public int getColumnDimension()

Returns the number of columns of this matrix.

Specified by:
  `getColumnDimension` in interface `AnyMatrix`
Specified by:
  `getColumnDimension` in class `AbstractRealMatrix`
Returns:
  the number of columns.

#### operate

    public double[] operate(double[] v)
                     throws DimensionMismatchException

Returns the result of multiplying this by the vector `v`.

Specified by:
  `operate` in interface `RealMatrix`
Overrides:
  `operate` in class `AbstractRealMatrix`
Parameters:
  `v` - the vector to operate on
Returns:
  `this * v`
Throws:
  `DimensionMismatchException` - if the length of `v` does not match the column dimension of `this`.

#### preMultiply

    public double[] preMultiply(double[] v)
                         throws DimensionMismatchException

Returns the (row) vector result of premultiplying this by the vector `v`.

Specified by:
  `preMultiply` in interface `RealMatrix`
Overrides:
  `preMultiply` in class `AbstractRealMatrix`
Parameters:
  `v` - the row vector to premultiply by
Returns:
  `v * this`
Throws:
  `DimensionMismatchException` - if the length of `v` does not match the row dimension of `this`.

#### walkInRowOrder

    public double walkInRowOrder(RealMatrixChangingVisitor visitor)

Visit (and possibly change) all matrix entries in row order.

Row order starts at upper left and iterating through all elements of a row from left to right before going to the leftmost element of the next row.

Specified by:
  `walkInRowOrder` in interface `RealMatrix`
Overrides:
  `walkInRowOrder` in class `AbstractRealMatrix`
Parameters:
  `visitor` - visitor used to process all matrix entries
Returns:
  the value returned by `RealMatrixChangingVisitor.end()` at the end of the walk
See Also:
  `RealMatrix.walkInRowOrder(RealMatrixPreservingVisitor)`, `RealMatrix.walkInRowOrder(RealMatrixChangingVisitor, int, int, int, int)`, `RealMatrix.walkInRowOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `RealMatrix.walkInColumnOrder(RealMatrixChangingVisitor)`, `RealMatrix.walkInColumnOrder(RealMatrixPreservingVisitor)`, `RealMatrix.walkInColumnOrder(RealMatrixChangingVisitor, int, int, int, int)`, `RealMatrix.walkInColumnOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `RealMatrix.walkInOptimizedOrder(RealMatrixChangingVisitor)`, `RealMatrix.walkInOptimizedOrder(RealMatrixPreservingVisitor)`, `RealMatrix.walkInOptimizedOrder(RealMatrixChangingVisitor, int, int, int, int)`, `RealMatrix.walkInOptimizedOrder(RealMatrixPreservingVisitor, int, int, int, int)`

#### walkInRowOrder

    public double walkInRowOrder(RealMatrixPreservingVisitor visitor)

Visit (but don't change) all matrix entries in row order.

Row order starts at upper left and iterating through all elements of a row from left to right before going to the leftmost element of the next row.

Specified by:
  `walkInRowOrder` in interface `RealMatrix`
Overrides:
  `walkInRowOrder` in class `AbstractRealMatrix`
Parameters:
  `visitor` - visitor used to process all matrix entries
Returns:
  the value returned by `RealMatrixPreservingVisitor.end()` at the end of the walk
See Also:
  `RealMatrix.walkInRowOrder(RealMatrixChangingVisitor)`, `RealMatrix.walkInRowOrder(RealMatrixChangingVisitor, int, int, int, int)`, `RealMatrix.walkInRowOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `RealMatrix.walkInColumnOrder(RealMatrixChangingVisitor)`, `RealMatrix.walkInColumnOrder(RealMatrixPreservingVisitor)`, `RealMatrix.walkInColumnOrder(RealMatrixChangingVisitor, int, int, int, int)`, `RealMatrix.walkInColumnOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `RealMatrix.walkInOptimizedOrder(RealMatrixChangingVisitor)`, `RealMatrix.walkInOptimizedOrder(RealMatrixPreservingVisitor)`, `RealMatrix.walkInOptimizedOrder(RealMatrixChangingVisitor, int, int, int, int)`, `RealMatrix.walkInOptimizedOrder(RealMatrixPreservingVisitor, int, int, int, int)`

#### walkInRowOrder

    public double walkInRowOrder(RealMatrixChangingVisitor visitor,
                        int startRow,
                        int endRow,
                        int startColumn,
                        int endColumn)
                          throws OutOfRangeException,
                                 NumberIsTooSmallException

Visit (and possibly change) some matrix entries in row order.

Row order starts at upper left and iterating through all elements of a row from left to right before going to the leftmost element of the next row.

Specified by:
  `walkInRowOrder` in interface `RealMatrix`
Overrides:
  `walkInRowOrder` in class `AbstractRealMatrix`
Parameters:
  `visitor` - visitor used to process all matrix entries
  `startRow` - Initial row index
  `endRow` - Final row index (inclusive)
  `startColumn` - Initial column index
  `endColumn` - Final column index
Returns:
  the value returned by `RealMatrixChangingVisitor.end()` at the end of the walk
Throws:
  `OutOfRangeException` - if the indices are not valid.
  `NumberIsTooSmallException` - if `endRow < startRow` or `endColumn < startColumn`.
See Also:
  `RealMatrix.walkInRowOrder(RealMatrixChangingVisitor)`, `RealMatrix.walkInRowOrder(RealMatrixPreservingVisitor)`, `RealMatrix.walkInRowOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `RealMatrix.walkInColumnOrder(RealMatrixChangingVisitor)`, `RealMatrix.walkInColumnOrder(RealMatrixPreservingVisitor)`, `RealMatrix.walkInColumnOrder(RealMatrixChangingVisitor, int, int, int, int)`, `RealMatrix.walkInColumnOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `RealMatrix.walkInOptimizedOrder(RealMatrixChangingVisitor)`, `RealMatrix.walkInOptimizedOrder(RealMatrixPreservingVisitor)`, `RealMatrix.walkInOptimizedOrder(RealMatrixChangingVisitor, int, int, int, int)`, `RealMatrix.walkInOptimizedOrder(RealMatrixPreservingVisitor, int, int, int, int)`

#### walkInRowOrder

    public double walkInRowOrder(RealMatrixPreservingVisitor visitor,
                        int startRow,
                        int endRow,
                        int startColumn,
                        int endColumn)
                          throws OutOfRangeException,
                                 NumberIsTooSmallException

Visit (but don't change) some matrix entries in row order.

Row order starts at upper left and iterating through all elements of a row from left to right before going to the leftmost element of the next row.

Specified by:
  `walkInRowOrder` in interface `RealMatrix`
Overrides:
  `walkInRowOrder` in class `AbstractRealMatrix`
Parameters:
  `visitor` - visitor used to process all matrix entries
  `startRow` - Initial row index
  `endRow` - Final row index (inclusive)
  `startColumn` - Initial column index
  `endColumn` - Final column index
Returns:
  the value returned by `RealMatrixPreservingVisitor.end()` at the end of the walk
Throws:
  `OutOfRangeException` - if the indices are not valid.
  `NumberIsTooSmallException` - if `endRow < startRow` or `endColumn < startColumn`.
See Also:
  `RealMatrix.walkInRowOrder(RealMatrixChangingVisitor)`, `RealMatrix.walkInRowOrder(RealMatrixPreservingVisitor)`, `RealMatrix.walkInRowOrder(RealMatrixChangingVisitor, int, int, int, int)`, `RealMatrix.walkInColumnOrder(RealMatrixChangingVisitor)`, `RealMatrix.walkInColumnOrder(RealMatrixPreservingVisitor)`, `RealMatrix.walkInColumnOrder(RealMatrixChangingVisitor, int, int, int, int)`, `RealMatrix.walkInColumnOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `RealMatrix.walkInOptimizedOrder(RealMatrixChangingVisitor)`, `RealMatrix.walkInOptimizedOrder(RealMatrixPreservingVisitor)`, `RealMatrix.walkInOptimizedOrder(RealMatrixChangingVisitor, int, int, int, int)`, `RealMatrix.walkInOptimizedOrder(RealMatrixPreservingVisitor, int, int, int, int)`

#### walkInOptimizedOrder

    public double walkInOptimizedOrder(RealMatrixChangingVisitor visitor)

Visit (and possibly change) all matrix entries using the fastest possible order.

The fastest walking order depends on the exact matrix class. It may be different from traditional row or column orders.

Specified by:
  `walkInOptimizedOrder` in interface `RealMatrix`
Overrides:
  `walkInOptimizedOrder` in class `AbstractRealMatrix`
Parameters:
  `visitor` - visitor used to process all matrix entries
Returns:
  the value returned by `RealMatrixChangingVisitor.end()` at the end of the walk
See Also:
  `RealMatrix.walkInRowOrder(RealMatrixChangingVisitor)`, `RealMatrix.walkInRowOrder(RealMatrixPreservingVisitor)`, `RealMatrix.walkInRowOrder(RealMatrixChangingVisitor, int, int, int, int)`, `RealMatrix.walkInRowOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `RealMatrix.walkInColumnOrder(RealMatrixChangingVisitor)`, `RealMatrix.walkInColumnOrder(RealMatrixPreservingVisitor)`, `RealMatrix.walkInColumnOrder(RealMatrixChangingVisitor, int, int, int, int)`, `RealMatrix.walkInColumnOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `RealMatrix.walkInOptimizedOrder(RealMatrixPreservingVisitor)`, `RealMatrix.walkInOptimizedOrder(RealMatrixChangingVisitor, int, int, int, int)`, `RealMatrix.walkInOptimizedOrder(RealMatrixPreservingVisitor, int, int, int, int)`

#### walkInOptimizedOrder

    public double walkInOptimizedOrder(RealMatrixPreservingVisitor visitor)

Visit (but don't change) all matrix entries using the fastest possible order.

The fastest walking order depends on the exact matrix class. It may be different from traditional row or column orders.

Specified by:
  `walkInOptimizedOrder` in interface `RealMatrix`
Overrides:
  `walkInOptimizedOrder` in class `AbstractRealMatrix`
Parameters:
  `visitor` - visitor used to process all matrix entries
Returns:
  the value returned by `RealMatrixPreservingVisitor.end()` at the end of the walk
See Also:
  `RealMatrix.walkInRowOrder(RealMatrixChangingVisitor)`, `RealMatrix.walkInRowOrder(RealMatrixPreservingVisitor)`, `RealMatrix.walkInRowOrder(RealMatrixChangingVisitor, int, int, int, int)`, `RealMatrix.walkInRowOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `RealMatrix.walkInColumnOrder(RealMatrixChangingVisitor)`, `RealMatrix.walkInColumnOrder(RealMatrixPreservingVisitor)`, `RealMatrix.walkInColumnOrder(RealMatrixChangingVisitor, int, int, int, int)`, `RealMatrix.walkInColumnOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `RealMatrix.walkInOptimizedOrder(RealMatrixChangingVisitor)`, `RealMatrix.walkInOptimizedOrder(RealMatrixChangingVisitor, int, int, int, int)`, `RealMatrix.walkInOptimizedOrder(RealMatrixPreservingVisitor, int, int, int, int)`

#### walkInOptimizedOrder

    public double walkInOptimizedOrder(RealMatrixChangingVisitor visitor,
                              int startRow,
                              int endRow,
                              int startColumn,
                              int endColumn)
                                throws OutOfRangeException,
                                       NumberIsTooSmallException

Visit (and possibly change) some matrix entries using the fastest possible order.

The fastest walking order depends on the exact matrix class. It may be different from traditional row or column orders.

Specified by:
  `walkInOptimizedOrder` in interface `RealMatrix`
Overrides:
  `walkInOptimizedOrder` in class `AbstractRealMatrix`
Parameters:
  `visitor` - visitor used to process all matrix entries
  `startRow` - Initial row index
  `endRow` - Final row index (inclusive)
  `startColumn` - Initial column index
  `endColumn` - Final column index (inclusive)
Returns:
  the value returned by `RealMatrixChangingVisitor.end()` at the end of the walk
Throws:
  `OutOfRangeException` - if the indices are not valid.
  `NumberIsTooSmallException` - if `endRow < startRow` or `endColumn < startColumn`.
See Also:
  `RealMatrix.walkInRowOrder(RealMatrixChangingVisitor)`, `RealMatrix.walkInRowOrder(RealMatrixPreservingVisitor)`, `RealMatrix.walkInRowOrder(RealMatrixChangingVisitor, int, int, int, int)`, `RealMatrix.walkInRowOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `RealMatrix.walkInColumnOrder(RealMatrixChangingVisitor)`, `RealMatrix.walkInColumnOrder(RealMatrixPreservingVisitor)`, `RealMatrix.walkInColumnOrder(RealMatrixChangingVisitor, int, int, int, int)`, `RealMatrix.walkInColumnOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `RealMatrix.walkInOptimizedOrder(RealMatrixChangingVisitor)`, `RealMatrix.walkInOptimizedOrder(RealMatrixPreservingVisitor)`, `RealMatrix.walkInOptimizedOrder(RealMatrixPreservingVisitor, int, int, int, int)`

#### walkInOptimizedOrder

    public double walkInOptimizedOrder(RealMatrixPreservingVisitor visitor,
                              int startRow,
                              int endRow,
                              int startColumn,
                              int endColumn)
                                throws OutOfRangeException,
                                       NumberIsTooSmallException

Visit (but don't change) some matrix entries using the fastest possible order.

The fastest walking order depends on the exact matrix class. It may be different from traditional row or column orders.

Specified by:
  `walkInOptimizedOrder` in interface `RealMatrix`
Overrides:
  `walkInOptimizedOrder` in class `AbstractRealMatrix`
Parameters:
  `visitor` - visitor used to process all matrix entries
  `startRow` - Initial row index
  `endRow` - Final row index (inclusive)
  `startColumn` - Initial column index
  `endColumn` - Final column index (inclusive)
Returns:
  the value returned by `RealMatrixPreservingVisitor.end()` at the end of the walk
Throws:
  `OutOfRangeException` - if the indices are not valid.
  `NumberIsTooSmallException` - if `endRow < startRow` or `endColumn < startColumn`.
See Also:
  `RealMatrix.walkInRowOrder(RealMatrixChangingVisitor)`, `RealMatrix.walkInRowOrder(RealMatrixPreservingVisitor)`, `RealMatrix.walkInRowOrder(RealMatrixChangingVisitor, int, int, int, int)`, `RealMatrix.walkInRowOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `RealMatrix.walkInColumnOrder(RealMatrixChangingVisitor)`, `RealMatrix.walkInColumnOrder(RealMatrixPreservingVisitor)`, `RealMatrix.walkInColumnOrder(RealMatrixChangingVisitor, int, int, int, int)`, `RealMatrix.walkInColumnOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `RealMatrix.walkInOptimizedOrder(RealMatrixChangingVisitor)`, `RealMatrix.walkInOptimizedOrder(RealMatrixPreservingVisitor)`, `RealMatrix.walkInOptimizedOrder(RealMatrixChangingVisitor, int, int, int, int)`

#### blockHeight

    private int blockHeight(int blockRow)

Get the height of a block.

Parameters:
  `blockRow` - row index (in block sense) of the block
Returns:
  height (number of rows) of the block

#### blockWidth

    private int blockWidth(int blockColumn)

Get the width of a block.

Parameters:
  `blockColumn` - column index (in block sense) of the block
Returns:
  width (number of columns) of the block